#define	GPUs                                            \
  TESLA,FERMI,KEPLER,KEPLER2,MAXWELL,MAXWELL2,PASCAL

#define	__func_NAME__( a, b )			\
  API( a##b )

#define	DEF_prototype_by_GPU( func, ... )       \
  __EXPAND_proto__( func, GPUs, GPU_codes )
#define __EXPAND_proto__( func, ... )		\
  __EXPAND_proto( func, __VA_ARGS__)

#define	_prototype( func, GPU )                 \
  extern "C" __host__ void			\
  __func_NAME__( func, GPU ) func##_##args

#define	__EXPAND_proto( func, GPU1, GPU2, GPU3, GPU4, GPU5, GPU6, GPU7, ... ) \
  _prototype( func, );                                                  \
  _prototype( func, _##GPU1 );                                          \
  _prototype( func, _##GPU2 );                                          \
  _prototype( func, _##GPU3 );                                          \
  _prototype( func, _##GPU4 );                                          \
  _prototype( func, _##GPU5 );                                          \
  _prototype( func, _##GPU6 );                                          \
  _prototype( func, _##GPU7 )



#define	DGEMV_n_args                            \
  ( int blk,					\
    const double alpha, const double beta,	\
    const double * a, const double * x,		\
    double * y,					\
    const int lda,				\
    const int n1, const int n2 )
#define	DGEMV_t_args                            \
  ( int blk,					\
    const double alpha, const double beta,	\
    const double * a, const double * x,		\
    double * y,					\
    const int lda,				\
    const int n1, const int n2 )

DEF_prototype_by_GPU( DGEMV_n, GPUs );
DEF_prototype_by_GPU( DGEMV_t, GPUs );

extern "C"void API(DGEMV_n) DGEMV_n_args;
extern "C"void API(DGEMV_t) DGEMV_t_args;


#define	SGEMV_n_args				\
  ( int blk,                                    \
    const float alpha, const float beta,	\
    const float * a, const float * x,           \
    float * y,                                  \
    const int lda,                              \
    const int n1, const int n2 )
#define	SGEMV_t_args				\
  ( int blk,                                    \
    const float alpha, const float beta,	\
    const float * a, const float * x,           \
    float * y,                                  \
    const int lda,                              \
    const int n1, const int n2 )

DEF_prototype_by_GPU( SGEMV_n, GPUs );
DEF_prototype_by_GPU( SGEMV_t, GPUs );

extern "C"void API(SGEMV_n) SGEMV_n_args;
extern "C"void API(SGEMV_t) SGEMV_t_args;


#define DSYMVu_args                             \
  ( const int blk,				\
    const int n,                                \
    const double * a, const int lda,		\
    const double * x, double * y,               \
    const double alpha, const double beta )
#define DSYMVl_args                             \
  ( const int blk,				\
    const int n,                                \
    const double * a, const int lda,		\
    const double * x, double * y,               \
    const double alpha, const double beta )

DEF_prototype_by_GPU( DSYMVu, GPUs );
DEF_prototype_by_GPU( DSYMVl, GPUs );

extern "C"void API(DSYMVu) DSYMVu_args;
extern "C"void API(DSYMVl) DSYMVl_args;



#define SSYMVu_args                             \
  ( const int blk,                              \
    const int n,				\
    const float * a, const int lda,             \
    const float * x, float * y,                 \
    const float alpha, const float beta )
#define SSYMVl_args                             \
  ( const int blk,                              \
    const int n,				\
    const float * a, const int lda,             \
    const float * x, float * y,                 \
    const float alpha, const float beta )

DEF_prototype_by_GPU( SSYMVu, GPUs );
DEF_prototype_by_GPU( SSYMVl, GPUs );

extern "C"void API(SSYMVu) SSYMVu_args;
extern "C"void API(SSYMVl) SSYMVl_args;


#undef	__func_NAME__

