#if !defined(CURRENT_GPU)
#  include "../tuning/CURRENT_GPU"
#endif
#if !defined(GPU_ARCH)
#  define GPU_ARCH	CURRENT_GPU
#endif

#include "double.h"
#include "aspen_devel.h"

#include "dsymv_lower-X_template.cu"

extern "C" void
API(DSYMVl) ( const int blk,
              const int n, const scalar_t * a, const int lda,
              const scalar_t * x, scalar_t * y,
              const scalar_t alpha, const scalar_t beta )
{

  // y = alpha * A * x + beta * y
  // y(1:n1)
  // x(1:n2)

  if ( n <= 0 ) return;
  if ( alpha == makeCONST<double>(0) && beta == makeCONST<double>(1) ) return;

  int Ver = API(get_device_CC) ( );

  if ( CURRENT_GPU == Ver ) {
    API(DSYMVl_STUB) ( blk,
                       n, a, lda, x, y, alpha, beta );
  } else {
    ; /* unmatched */
  }

}

