#include "../tuning/CURRENT_GPU"

#if !defined(GPU_ARCH)
#  define GPU_ARCH	CURRENT_GPU
#endif

#include "float.h"
#include "aspen_devel.h"

#include "sgemv_n-X_template.cu"

extern "C" void
API(SGEMV_n) ( int blk,
	       const scalar_t alpha, const scalar_t beta,
	       const scalar_t * a, const scalar_t * x,
	       scalar_t * y,
	       const int lda,
	       const int n1, const int n2 )
{

  if ( n1 <= 0 || n2 <= 0 ) return;
  if ( alpha == makeCONST<float>(0) && beta == makeCONST<float>(1) ) return;

  int Ver = API(get_device_CC) ( );

  if ( CURRENT_GPU == Ver ) {
    API(SGEMV_n_STUB) ( blk,
                        alpha, beta, a, x, y, lda, n1, n2 );
  } else {
    ; /* unmatched */
  }

}

