#!/bin/sh

do_touch_header()
{
	if [ ! -e $1 ]; then
	if [ -e tuning-old/$MACHINE_DIR/$CUDA__DIR/$1 ]; then
		echo Copy tuning-old/$MACHINE_DIR/$CUDA__DIR/$1
		cp tuning-old/$MACHINE_DIR/$CUDA__DIR/$1 .
	else
		echo Copy tuning-old/default/$CUDA__DIR/$1
		cp tuning-old/default/$CUDA__DIR/$1 .
	fi
	fi
}

cd ../src; make get_dev_info; cd ../tuning

if [ x$CUDA_PATH != x ]; then
	export LD_LIBRARY_PATH=$CUDA_PATH/lib64:$LD_LIBRARY_PATH
fi

../src/get_dev_info $ASPEN_GPU_ID > DEV_INFO

DEVICE=`awk '/DEVICE= /{print $2}' DEV_INFO`
CUDA=`awk '/CUDA= /{print $2; i=1}END{if(i==0)print 6050}' DEV_INFO`

echo DEVICE $DEVICE
echo CUDA $CUDA

MACHINE_DIR=default
CUDA__DIR=6050
if [ -e tuning-old/$DEVICE ]; then
	MACHINE_DIR=$DEVICE
	if [ -e tuning-old/$DEVICE/$CUDA ]; then
		CUDA__DIR=$CUDA
	else
		CUDA__DIR=6050
	fi
	echo 'The configuration files tuned for '$DEVICE' with CUDA '$CUDA__DIR' are adopted.'
else
	MACHINE_DIR=default
	echo 'The default configuration files are adopted.'
	if [ -e tuning-old/$DEVICE/$CUDA ]; then
		CUDA__DIR=$CUDA
	else
		CUDA__DIR=6050
	fi
fi

for header in \
	dgemvn_opt4.h \
	dgemvn-auto2.h \
	sgemvn_opt4.h \
	sgemvn-auto2.h \
	dgemvt-at-opt.c \
	sgemvt-at-opt.c \
	dsymv-upper-auto.h \
	dsymv-upper-auto2.h \
	param-dsymvu.h \
	ssymv-upper-auto.h \
	ssymv-upper-auto2.h \
	param-ssymvu.h \
	dsymv-lower-auto.h \
	dsymv-lower-auto2.h \
	param-dsymvl.h \
	ssymv-lower-auto.h \
	ssymv-lower-auto2.h \
	param-ssymvl.h
do
	do_touch_header $header
done


