#if 0
<--/****************************************
Automatic Performance Tuning for SGEMV -T
Tue Jan 13 19:52:31 JST 2015
Host on newton.aics27.riken.jp
Device is GeForce-GTX-TITAN-Black
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="newton.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-TITAN-Black";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(15)
#endif
#if !defined(scalar_t)
#define scalar_t	float
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_SGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

#define	KERNEL_4	1
#define	KERNEL_5	1
#define	KERNEL_18	1
#define	KERNEL_19	1
#define	KERNEL_7	1
#define	KERNEL_8	1
#define	KERNEL_10	1
#define	KERNEL_11	1
#define	KERNEL_13	1
#define	KERNEL_0	1
#define	KERNEL_1	1
#define	KERNEL_2	1
#define	KERNEL_16	1

if ( n >= 1 && n < 255 ) {
	BLK = 10;
} else
if ( n >= 255 && n < 448 ) {
	BLK = 19;
} else
if ( n >= 448 && n < 960 ) {
	BLK = 8;
} else
if ( n >= 960 && n < 1200 ) {
	BLK = 19;
} else
if ( n >= 1200 && n < 1252 ) {
	BLK = 5;
} else
if ( n >= 1252 && n < 1440 ) {
	BLK = 13;
} else
if ( n >= 1440 && n < 1920 ) {
	BLK = 11;
} else
if ( n >= 1920 && n < 2160 ) {
	BLK = 5;
} else
if ( n >= 2160 && n < 2400 ) {
	BLK = 19;
} else
if ( n >= 2400 && n < 2880 ) {
	BLK = 8;
} else
if ( n >= 2880 && n < 3000 ) {
	BLK = 4;
} else
if ( n >= 3000 && n < 3240 ) {
	BLK = 16;
} else
if ( n >= 3240 && n < 3360 ) {
	BLK = 7;
} else
if ( n >= 3360 && n < 3600 ) {
	BLK = 4;
} else
if ( n >= 3600 && n < 3840 ) {
	BLK = 8;
} else
if ( n >= 3840 && n < 4200 ) {
	BLK = 4;
} else
if ( n >= 4200 && n < 4320 ) {
	BLK = 5;
} else
if ( n >= 4320 && n < 4620 ) {
	BLK = 18;
} else
if ( n >= 4620 && n < 4656 ) {
	BLK = 4;
} else
if ( n >= 4656 && n < 4800 ) {
	BLK = 8;
} else
if ( n >= 4800 && n < 4860 ) {
	BLK = 16;
} else
if ( n >= 4860 && n < 5040 ) {
	BLK = 18;
} else
if ( n >= 5040 && n < 5280 ) {
	BLK = 7;
} else
if ( n >= 5280 && n < 5400 ) {
	BLK = 4;
} else
if ( n >= 5400 && n < 5460 ) {
	BLK = 18;
} else
if ( n >= 5460 && n < 5760 ) {
	BLK = 7;
} else
if ( n >= 5760 && n < 5880 ) {
	BLK = 18;
} else
if ( n >= 5880 && n < 6000 ) {
	BLK = 4;
} else
if ( n >= 6000 && n < 6120 ) {
	BLK = 2;
} else
if ( n >= 6120 && n < 6240 ) {
	BLK = 7;
} else
if ( n >= 6240 && n < 6300 ) {
	BLK = 18;
} else
if ( n >= 6300 && n < 6338 ) {
	BLK = 0;
} else
if ( n >= 6338 && n < 6480 ) {
	BLK = 2;
} else
if ( n >= 6480 && n < 6593 ) {
	BLK = 0;
} else
if ( n >= 6593 && n < 6600 ) {
	BLK = 4;
} else
if ( n >= 6600 && n < 6720 ) {
	BLK = 7;
} else
if ( n >= 6720 && n < 6750 ) {
	BLK = 0;
} else
if ( n >= 6750 && n < 6840 ) {
	BLK = 2;
} else
if ( n >= 6840 && n < 7161 ) {
	BLK = 0;
} else
if ( n >= 7161 && n < 7200 ) {
	BLK = 2;
} else
if ( n >= 7200 && n < 7501 ) {
	BLK = 0;
} else
if ( n >= 7501 && n < 7560 ) {
	BLK = 2;
} else
if ( n >= 7560 && n < 16875 ) {
	BLK = 0;
} else
if ( n >= 16875 && n < 16991 ) {
	BLK = 1;
} else
if ( n >= 16991 && n < 17100 ) {
	BLK = 0;
} else
if ( n >= 17100 && n < 36118 ) {
	BLK = 1;
} else
if ( n >= 36118 && n < 100000000 ) {
	BLK = 1;
}

#if 1
	int ii=BLK;
        #define SGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
                GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
                ( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		SGEMVT_KERNEL_ ( 384 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		SGEMVT_KERNEL_ ( 384 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		SGEMVT_KERNEL_ ( 320 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		SGEMVT_KERNEL_ ( 320 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		SGEMVT_KERNEL_ ( 192 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		SGEMVT_KERNEL_ ( 160 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		SGEMVT_KERNEL_ ( 192 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		SGEMVT_KERNEL_ ( 256 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		SGEMVT_KERNEL_ ( 128 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		SGEMVT_KERNEL_ ( 384 , 1 , 5, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		SGEMVT_KERNEL_ ( 96 , 4 , 4, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		SGEMVT_KERNEL_ ( 64 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		SGEMVT_KERNEL_ ( 224 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		SGEMVT_KERNEL_ ( 64 , 4 , 3, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		SGEMVT_KERNEL_ ( 64 , 5 , 3, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		SGEMVT_KERNEL_ ( 256 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		SGEMVT_KERNEL_ ( 224 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		SGEMVT_KERNEL_ ( 384 , 1 , 6, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		SGEMVT_KERNEL_ ( 288 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		SGEMVT_KERNEL_ ( 96 , 2 , 4, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

