#if 0
<--/****************************************
Automatic Performance Tuning for SSYMV-L
Fri Jul 15 09:13:28 JST 2016
Host on gauss.aics27.riken.jp
Device is GeForce-GTX-750-Ti
****************************************/-->
// device name
DEVICE= GeForce-GTX-750-Ti
// the number of multi-processors
MP= 5
// compute-compatibility generation
CG= 500
// capacity of the global memory
MAXmem= 2096694016
// for double or cuFloatComplex
MAXDIM= 15379
// for float
MAXDIM2= 21750
// for cuFloatComplex or DD
MAXDIM3= 10875
// for DD-Complex
MAXDIM4= 7689
// cuda version
CUDA= 8000
<--
#define CURRENT_GPU 500
-->
#endif
{
//==========
if(blk==-1){
	#include "ssymv-lower-auto2.h"
}
//==========
#if 0
struct ssymv_auto_tuning_param_t { 
	int	BLOCK_SIZE, VX, UX, MULTI, MX; 
} PARAM[22] = {
	{ 32, 2, 38, 12, 1 },
	{ 32, 4, 76, 6, 6 },
	{ 32, 2, 38, 12, 0 },
	{ 32, 2, 34, 14, 4 },
	{ 32, 2, 38, 12, 5 },
	{ 32, 2, 34, 14, 7 },
	{ 32, 2, 38, 12, 4 },
	{ 32, 3, 51, 9, 2 },
	{ 32, 3, 51, 9, 4 },
	{ 64, 1, 14, 16, 3 },
	{ 32, 8, 72, 5, 4 },
	{ 32, 3, 48, 9, 8 },
	{ 32, 2, 34, 14, 2 },
	{ 32, 2, 38, 12, 7 },
	{ 32, 2, 38, 12, 6 },
	{ 32, 2, 38, 12, 3 },
	{ 32, 2, 38, 12, 8 },
	{ 32, 2, 34, 14, 3 },
	{ 32, 8, 48, 5, 7 },
	{ 32, 8, 48, 5, 5 },
	{ 0, 0, 0, 0, 0 }
};
#endif
//==========
switch ( BLK ) {
#if KERNEL_1
case 1:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 2, 38, 12, 1 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_2
case 2:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 4, 76, 6, 6 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_3
case 3:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 2, 38, 12, 0 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_4
case 4:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 2, 34, 14, 4 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_5
case 5:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 2, 38, 12, 5 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_6
case 6:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 2, 34, 14, 7 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_7
case 7:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 2, 38, 12, 4 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_8
case 8:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 3, 51, 9, 2 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_9
case 9:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 3, 51, 9, 4 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_10
case 10:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 1, 14, 16, 3 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_11
case 11:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 8, 72, 5, 4 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_12
case 12:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 3, 48, 9, 8 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_13
case 13:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 2, 34, 14, 2 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_14
case 14:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 2, 38, 12, 7 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_15
case 15:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 2, 38, 12, 6 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_16
case 16:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 2, 38, 12, 3 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_17
case 17:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 2, 38, 12, 8 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_18
case 18:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 2, 34, 14, 3 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_19
case 19:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 8, 48, 5, 7 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_20
case 20:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 8, 48, 5, 5 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
default:
	break;
}
//==========
}
