#if 0
<--/****************************************
Automatic Performance Tuning for SGEMV -T
Fri May 27 21:13:23 JST 2016
Host on newton.aics27.riken.jp
Device is GeForce-GTX-TITAN-Black
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="newton.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-TITAN-Black";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(15)
#endif
#if !defined(scalar_t)
#define scalar_t	float
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_SGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;


#define	KERNEL_17	1
#define	KERNEL_18	1
#define	KERNEL_5	1
#define	KERNEL_19	1
#define	KERNEL_7	1
#define	KERNEL_10	1
#define	KERNEL_11	1
#define	KERNEL_12	1
#define	KERNEL_13	1
#define	KERNEL_0	1
#define	KERNEL_1	1
#define	KERNEL_2	1

if ( n >= 1 && n < 130 ) {
	BLK = 17;
} else
if ( n >= 130 && n < 281 ) {
	BLK = 12;
} else
if ( n >= 281 && n < 519 ) {
	BLK = 18;
} else
if ( n >= 519 && n < 960 ) {
	BLK = 7;
} else
if ( n >= 960 && n < 1200 ) {
	BLK = 11;
} else
if ( n >= 1200 && n < 1260 ) {
	BLK = 12;
} else
if ( n >= 1260 && n < 1440 ) {
	BLK = 10;
} else
if ( n >= 1440 && n < 1762 ) {
	BLK = 18;
} else
if ( n >= 1762 && n < 1920 ) {
	BLK = 7;
} else
if ( n >= 1920 && n < 2160 ) {
	BLK = 10;
} else
if ( n >= 2160 && n < 2400 ) {
	BLK = 2;
} else
if ( n >= 2400 && n < 2880 ) {
	BLK = 18;
} else
if ( n >= 2880 && n < 3000 ) {
	BLK = 2;
} else
if ( n >= 3000 && n < 3233 ) {
	BLK = 19;
} else
if ( n >= 3233 && n < 3600 ) {
	BLK = 2;
} else
if ( n >= 3600 && n < 3729 ) {
	BLK = 5;
} else
if ( n >= 3729 && n < 3840 ) {
	BLK = 18;
} else
if ( n >= 3840 && n < 4200 ) {
	BLK = 2;
} else
if ( n >= 4200 && n < 4320 ) {
	BLK = 10;
} else
if ( n >= 4320 && n < 4410 ) {
	BLK = 1;
} else
if ( n >= 4410 && n < 4620 ) {
	BLK = 5;
} else
if ( n >= 4620 && n < 4800 ) {
	BLK = 2;
} else
if ( n >= 4800 && n < 4945 ) {
	BLK = 1;
} else
if ( n >= 4945 && n < 5040 ) {
	BLK = 5;
} else
if ( n >= 5040 && n < 5325 ) {
	BLK = 1;
} else
if ( n >= 5325 && n < 5400 ) {
	BLK = 2;
} else
if ( n >= 5400 && n < 10260 ) {
	BLK = 1;
} else
if ( n >= 10260 && n < 10440 ) {
	BLK = 13;
} else
if ( n >= 10440 && n < 10530 ) {
	BLK = 1;
} else
if ( n >= 10530 && n < 11025 ) {
	BLK = 13;
} else
if ( n >= 11025 && n < 11070 ) {
	BLK = 0;
} else
if ( n >= 11070 && n < 11250 ) {
	BLK = 13;
} else
if ( n >= 11250 && n < 11340 ) {
	BLK = 0;
} else
if ( n >= 11340 && n < 11547 ) {
	BLK = 13;
} else
if ( n >= 11547 && n < 11610 ) {
	BLK = 0;
} else
if ( n >= 11610 && n < 12375 ) {
	BLK = 13;
} else
if ( n >= 12375 && n < 12420 ) {
	BLK = 0;
} else
if ( n >= 12420 && n < 12600 ) {
	BLK = 13;
} else
if ( n >= 12600 && n < 12690 ) {
	BLK = 0;
} else
if ( n >= 12690 && n < 12917 ) {
	BLK = 13;
} else
if ( n >= 12917 && n < 12960 ) {
	BLK = 0;
} else
if ( n >= 12960 && n < 13725 ) {
	BLK = 13;
} else
if ( n >= 13725 && n < 13770 ) {
	BLK = 0;
} else
if ( n >= 13770 && n < 13950 ) {
	BLK = 13;
} else
if ( n >= 13950 && n < 14040 ) {
	BLK = 0;
} else
if ( n >= 14040 && n < 15075 ) {
	BLK = 13;
} else
if ( n >= 15075 && n < 15120 ) {
	BLK = 0;
} else
if ( n >= 15120 && n < 15300 ) {
	BLK = 13;
} else
if ( n >= 15300 && n < 15390 ) {
	BLK = 0;
} else
if ( n >= 15390 && n < 16425 ) {
	BLK = 13;
} else
if ( n >= 16425 && n < 16470 ) {
	BLK = 0;
} else
if ( n >= 16470 && n < 16650 ) {
	BLK = 13;
} else
if ( n >= 16650 && n < 16740 ) {
	BLK = 0;
} else
if ( n >= 16740 && n < 17775 ) {
	BLK = 13;
} else
if ( n >= 17775 && n < 17820 ) {
	BLK = 0;
} else
if ( n >= 17820 && n < 18014 ) {
	BLK = 13;
} else
if ( n >= 18014 && n < 18090 ) {
	BLK = 0;
} else
if ( n >= 18090 && n < 19125 ) {
	BLK = 13;
} else
if ( n >= 19125 && n < 19170 ) {
	BLK = 0;
} else
if ( n >= 19170 && n < 19378 ) {
	BLK = 13;
} else
if ( n >= 19378 && n < 19440 ) {
	BLK = 0;
} else
if ( n >= 19440 && n < 20475 ) {
	BLK = 13;
} else
if ( n >= 20475 && n < 20520 ) {
	BLK = 0;
} else
if ( n >= 20520 && n < 20743 ) {
	BLK = 13;
} else
if ( n >= 20743 && n < 20790 ) {
	BLK = 0;
} else
if ( n >= 20790 && n < 21825 ) {
	BLK = 13;
} else
if ( n >= 21825 && n < 21870 ) {
	BLK = 0;
} else
if ( n >= 21870 && n < 22107 ) {
	BLK = 13;
} else
if ( n >= 22107 && n < 22140 ) {
	BLK = 0;
} else
if ( n >= 22140 && n < 23175 ) {
	BLK = 13;
} else
if ( n >= 23175 && n < 23220 ) {
	BLK = 0;
} else
if ( n >= 23220 && n < 24525 ) {
	BLK = 13;
} else
if ( n >= 24525 && n < 24570 ) {
	BLK = 0;
} else
if ( n >= 24570 && n < 25875 ) {
	BLK = 13;
} else
if ( n >= 25875 && n < 25920 ) {
	BLK = 0;
} else
if ( n >= 25920 && n < 27225 ) {
	BLK = 13;
} else
if ( n >= 27225 && n < 27270 ) {
	BLK = 0;
} else
if ( n >= 27270 && n < 28575 ) {
	BLK = 13;
} else
if ( n >= 28575 && n < 28620 ) {
	BLK = 0;
} else
if ( n >= 28620 && n < 29925 ) {
	BLK = 13;
} else
if ( n >= 29925 && n < 29970 ) {
	BLK = 0;
} else
if ( n >= 29970 && n < 31278 ) {
	BLK = 13;
} else
if ( n >= 31278 && n < 31320 ) {
	BLK = 0;
} else
if ( n >= 31320 && n < 38120 ) {
	BLK = 13;
} else
if ( n >= 38120 && n < 100000000 ) {
	BLK = 13;
}

#if 1
	int ii=BLK;
        #define SGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
                GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
                ( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		SGEMVT_KERNEL_ ( 384 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		SGEMVT_KERNEL_ ( 384 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		SGEMVT_KERNEL_ ( 192 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		SGEMVT_KERNEL_ ( 256 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		SGEMVT_KERNEL_ ( 352 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		SGEMVT_KERNEL_ ( 288 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		SGEMVT_KERNEL_ ( 256 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		SGEMVT_KERNEL_ ( 96 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		SGEMVT_KERNEL_ ( 320 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		SGEMVT_KERNEL_ ( 128 , 1 , 8, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		SGEMVT_KERNEL_ ( 160 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		SGEMVT_KERNEL_ ( 96 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		SGEMVT_KERNEL_ ( 96 , 3 , 4, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		SGEMVT_KERNEL_ ( 320 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		SGEMVT_KERNEL_ ( 96 , 2 , 2, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		SGEMVT_KERNEL_ ( 128 , 2 , 6, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		SGEMVT_KERNEL_ ( 224 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		SGEMVT_KERNEL_ ( 32 , 5 , 3, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		SGEMVT_KERNEL_ ( 128 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		SGEMVT_KERNEL_ ( 224 , 1 , 4, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

